<?php defined('BASEPATH') OR exit('No direct script access allowed');

class Permission
{
	public function __construct()
	{

	}

	public static function check($class__method, $IdEstado = null)
	{
		// $class__method: ej. Solicitud::edit
		// cualq otro valor q quiero pasar para utilizar aca.
        
		if(!$class__method)
			throw new Exception("No se pudo verificar el permiso para ejecutar esta operación.[Cod:1]");

		list($class, $method) = explode('::', $class__method);

		$class = strtolower($class);
		$method = strtolower($method);

		/*var_dump($class);
		var_dump($method);*/
        
        $CI =& get_instance();
		
		if(!$CI->session->userdata('usuario'))
			throw new Exception("Debes estar logueado para ejecutar esta operación.[Cod:2]");

		$my_Perfil = strtoupper($CI->session->userdata('Perfil'));
		if(!$my_Perfil)
			throw new Exception("Debes estar logueado para ejecutar esta operación.[Cod:2]");
		
		$permisos = self::getPermission();

		if(!array_key_exists($class, $permisos))
			throw new Exception("No se pudo verificar el permiso para ejecutar esta operación.[Cod:2]");

		
        /*print($method);
        print($class);*/
        if(!array_key_exists($method, $permisos[$class]))
            
			throw new Exception("No se pudo verificar el permiso para ejecutar esta operación.[Cod:3]");

		if(!array_key_exists('roles', $permisos[$class][$method]))
			throw new Exception("No se pudo verificar el permiso para ejecutar esta operación.[Cod:4]");
		
		$allowed_roles =  $permisos[$class][$method]['roles'];

		$my_rol_str = getRolStr($my_Perfil);

		// pre($allowed_roles);
		// pre($my_rol_str . ' ('.$my_IdRol.')');

		if(!in_array($my_rol_str, $allowed_roles))
			throw new Exception("Sin permiso para la operación.[".$class__method."]");

		return true;
	}

	private static function getPermission()
	{
		$permisos = array();
//ADMINISTRADOR - ABOGADO - CONTADOR - SUPERVISOR - ADMINAFILIADO - ADMINEMPRESA - ADMINAMBOS - ADMINAMBOSAPORTES


		/* Empresa */
		$permisos['empresa'] = array();
		$permisos['empresa']['index'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAFILIADO','ADMINEMPRESA','ADMINAMBOS','ADMINAMBOSAPORTES'));
		$permisos['empresa']['grabarempresa'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINEMPRESA','ADMINAMBOS','ADMINAMBOSAPORTES'));
		$permisos['empresa']['eliminarobservacion'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINEMPRESA', 'ADMINAMBOSAPORTES'));
        $permisos['empresa']['bajaactivarempresa'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINEMPRESA','ADMINAMBOS','ADMINAMBOSAPORTES'));

		
		/* Afiliado */
		$permisos['afiliado'] = array();
		$permisos['afiliado']['index'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAFILIADO','ADMINEMPRESA','ADMINAMBOS','ADMINAMBOSAPORTES'));
		$permisos['afiliado']['grabarafiliado'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINAFILIADO','ADMINAMBOS','ADMINAMBOSAPORTES'));
		$permisos['afiliado']['eliminarAfiliado'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINAFILIADO','ADMINAMBOS','ADMINAMBOSAPORTES'));
        $permisos['afiliado']['cambioempresaafiliado'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINAFILIADO','ADMINAMBOS','ADMINAMBOSAPORTES'));
        $permisos['afiliado']['bajaActivarAfiliado'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINAFILIADO','ADMINAMBOS','ADMINAMBOSAPORTES'));
        $permisos['afiliado']['eliminarobservacion'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINAFILIADO','ADMINAMBOS','ADMINAMBOSAPORTES'));
        
        

        /*Familiar*/
        $permisos['familiar'] = array();
        $permisos['familiar']['grabarFamiliar'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINAFILIADO','ADMINAMBOS','ADMINAMBOSAPORTES'));
        $permisos['familiar']['eliminarFamiliar'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR','ADMINAFILIADO','ADMINAMBOS','ADMINAMBOSAPORTES'));

		/* Aportes */
		$permisos['aporte'] = array();
		$permisos['aporte']['index'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['grabaraporte'] = array('roles' => array('CONTADOR'));
		$permisos['aporte']['getaportes'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['getaporte'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['getmontosestimados'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['getempresaid'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['getempresacuitsucursal'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['getempresaidempresaaniomes'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['gettipoaporte'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','ABOGADO','CONTADOR','ADMINAMBOSAPORTES'));
		$permisos['aporte']['eliminaraporte'] = array('roles' => array('CONTADOR'));
		$permisos['aporte']['grabarAporte'] = array('roles' => array('CONTADOR'));
		
        /*Cctcategorias*/
        $permisos['cctcategorias'] = array();
        $permisos['cctcategorias']['index'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR'));
        $permisos['cctcategorias']['mostrarCategorias'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR'));
        $permisos['cctcategorias']['getListadoCategoriaSueldos'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR'));
        $permisos['cctcategorias']['getListadoCategoriaSueldos'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR'));
        $permisos['cctcategorias']['add'] = array('roles' => array('ADMINISTRADOR'));
        $permisos['cctcategorias']['grabarSueldoBasicoCategoria'] = array('roles' => array('ADMINISTRADOR','CONTADOR'));
        $permisos['cctcategorias']['eliminarSueldoBasicoCategoria'] = array('roles' => array('ADMINISTRADOR','CONTADOR'));
        $permisos['cctcategorias']['eliminarCategoria'] = array('roles' => array('ADMINISTRADOR'));
        $permisos['cctcategorias']['grabarCategoria'] = array('roles' => array('ADMINISTRADOR'));

        
        

        /* Calculadora */
        $permisos['cctsueldos'] = array();
        $permisos['cctsueldos']['index'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR'));
        $permisos['cctsueldos']['calcularSueldo'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR'));
        $permisos['cctsueldos']['calcularSueldo'] = array('roles' => array('ADMINISTRADOR','SUPERVISOR','CONTADOR'));

        
		return $permisos;
	}

	public static function menu_solicitud()
	{
		if(is_administrator())
			return true;

		if(is_compras())
			return true;

		if(is_valida())
			return true;

		if(is_usuario())
			return true;

		return false;
	}

	public static function menu_productos()
	{
		if(is_administrator())
			return true;

		if(is_compras())
			return true;

		if(is_valida())
			return true;

		return false;
	}

	public static function menu_CCT()
	{
		if(is_administrator()) return true;
//print $this->session->userdata('Perfil');
		//if($this->session->userdata('Perfil')=='Contador')
			
		

		//if(is_compras())
		//	return true;

		//if(is_valida())
		//	return true;

		return false;
	}

	public static function menu_compras_ordenes()
	{
		if(is_administrator())
			return true;

		if(is_compras())
			return true;

		if(is_valida())
			return true;

		return false;
	}

	public static function menu_compras_constataciones()
	{
		if(is_administrator())
			return true;

		if(is_compras())
			return true;

		if(is_valida())
			return true;

		return false;
	}

	public static function menu_usuarios()
	{
		if(is_administrator())
			return true;

		if(is_compras())
			return true;

		return false;
	}




	public static function menu_logs()
	{
		if(is_administrator())
			return true;

		return false;
	}

	public static function menu_ayuda()
	{
		if(is_administrator())
			return true;

		if(is_compras())
			return true;

		if(is_valida())
			return true;

		if(is_usuario())
			return true;

		return false;
	}



    public static function replicar($row)
    {
        if(is_owner($row))
        	return true;

        if(is_administrator())
        	return true;

        return false;
    }

    public static function ver($row)
    {
    	if(!self::editar($row))
    		return true;

    	return false;

    	/*
    	if(is_compras())
    		return true;

    	if(is_valida())
    		return true;
   
        if(is_administrator())
    		return true;

        if(is_invitado_lectura($row))
            return true;

        return false;
        */
    }

    public static function editar($row)
    {
    	$CI =& get_instance();
    	$CI->load->model('estado_model');
		
		$IdEstado = getTruncatedFieldFromReal('h.IdEstado');

		$allowed = array(
			Estado_model::INICIADO,
			Estado_model::CURSANDO,
			Estado_model::RECHAZADO,
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_owner($row))
            return true;

        if(is_invitado_escritura($row))
            return true;

        return false;
    }

    public static function cursar($row)
    {
        $CI =& get_instance();
    	$CI->load->model('estado_model');

    	$IdEstado = getTruncatedFieldFromReal('h.IdEstado');
    	
    	$allowed = array(
			Estado_model::INICIADO,
			Estado_model::RECHAZADO,
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_owner($row))
            return true;

        return false;
    }

    public static function aprobar($row)
    {
        $CI =& get_instance();
    	$CI->load->model('estado_model');

    	$IdEstado = getTruncatedFieldFromReal('h.IdEstado');
    	
    	$allowed = array(
			Estado_model::CURSANDO,
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_valida())
            return true;

        return false;
    }

    public static function rechazar($row)
    {
        $CI =& get_instance();
    	$CI->load->model('estado_model');

    	$IdEstado = getTruncatedFieldFromReal('h.IdEstado');
    	
    	$allowed = array(
			//Estado_model::INICIADO,  
		    Estado_model::CURSANDO,  
		    // Estado_model::VALIDADO,  
		    // Estado_model::RECHAZADO, 
		    // Estado_model::PENDIENTE, 
		    // Estado_model::FALTANTE,  
		    // Estado_model::PROCESADO, 
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_valida())
            return true;

        return false;
    }

    public static function pendiente($row)
    {
        $CI =& get_instance();
    	$CI->load->model('estado_model');

    	$IdEstado = getTruncatedFieldFromReal('h.IdEstado');
    	
    	$allowed = array(  
		    Estado_model::VALIDADO,  
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_compras())
            return true;

        return false;
    }

    public static function faltante($row)
    {
        $CI =& get_instance();
    	$CI->load->model('estado_model');

    	$IdEstado = getTruncatedFieldFromReal('h.IdEstado');
    	
    	$allowed = array(  
		    Estado_model::PENDIENTE,  
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_compras())
            return true;

        return false;
    }

    public static function procesado($row)
    {
        $CI =& get_instance();
    	$CI->load->model('estado_model');

    	$IdEstado = getTruncatedFieldFromReal('h.IdEstado');
    	
    	$allowed = array(  
		    Estado_model::PENDIENTE,  
		    Estado_model::FALTANTE,  
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_compras())
            return true;

        return false;
    }

    public static function entregado($row)
    {
        $CI =& get_instance();
    	$CI->load->model('estado_model');

    	$IdEstado = getTruncatedFieldFromReal('h.IdEstado');
    	
    	$allowed = array(  
		    Estado_model::PROCESADO,  
		);

    	if(!in_array($row->$IdEstado, $allowed))
    		return false;
   
        if(is_administrator())
    		return true;
    	
        if(is_compras())
            return true;

        return false;
    }

    public static function invitar($row)
    {
    	if(is_owner($row))
        	return true;

        if(is_administrator())
        	return true;

        return false;
    }

    public static function ver_archivo($row)
    {
    	if(is_owner($row))
        	return true;

        if(is_invitado_lectura($row))
        	return true;

        if(is_administrator())
        	return true;

        if(is_valida())
        	return true;

        if(is_compras())
        	return true;

        return false;
    }

    public static function change_status($old_IdEstado = null, $new_IdEstado = null)
    {
    	if(!$old_IdEstado)
    		throw new Exception("El estado no se ha definido.");

    	if(!$new_IdEstado)
    		throw new Exception("El nuevo estado no se ha definido.");

    	$CI =& get_instance();
    	$CI->load->model('Estado_model');
    	$old_estado_str = $CI->estado_model->getEstadoStr($old_IdEstado); // viene upper
    	$new_estado_str = $CI->estado_model->getEstadoStr($new_IdEstado); // viene upper

	   	$old_estado_lower = strtolower($old_estado_str);
    	$new_estado_lower = strtolower($new_estado_str);

    	$is_posible = false;
    	
    	$estados = array();
    	$estados['INICIADO'] = array('CURSANDO');
    	$estados['CURSANDO'] = array('VALIDADO','RECHAZADO');
    	$estados['VALIDADO'] = array('RECHAZADO','PENDIENTE');
    	$estados['RECHAZADO'] = array('CURSANDO');
    	$estados['PENDIENTE'] = array('FALTANTE','PROCESADO');
    	$estados['FALTANTE'] = array('PROCESADO','ENTREGADO');
    	$estados['PROCESADO'] = array('ENTREGADO');
    	$estados['ENTREGADO'] = array(); // en este punto ya no puede cambiar más de estado.

    	if(array_key_exists($old_estado_str, $estados))
    	{
    		if(in_array($new_estado_str, $estados[$old_estado_str]))
    		{
    			$is_posible = true;
    		}
    	}
    	
    	if(!$is_posible)
    		throw new Exception("No es posible cambiar el estado de '{$old_estado_lower}' a '{$new_estado_lower}'.");

    	return true;
    }

}