<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Aporte_model extends CI_Model {

	public function getAportes($IdEmpresaAporte, $PeriodoAporte,$MesAporte,$FiltroFecha)
    {
        $this->db->select ('aporte.IdAporte, aporte.IdEmpresa, empresa.CUIT, RazonSocial, Anio, Mes, ImporteSindicato, ImporteFondoExtra, ImporteConvenio, ImporteOtro, 
            FechaAcreditacion');
        $this->db->from('aporte');
        $this->db->join('empresa', 'aporte.IdEmpresa = empresa.IdEmpresa');
        //$this->db->join('TipoAporte', 'aporte.CodTipoAporte = TipoAporte.CodTipoAporte');

        $this->db->where('aporte.FechaBaja is null');
        /*$this->db->where('LEFT(cuota,4)=YEAR(NOW()) OR LEFT(cuota,4)=YEAR(NOW())-1');*/
        if ($IdEmpresaAporte!=0){
            $this->db->where('empresa.IdEmpresa = '.$IdEmpresaAporte);
        }
        if ($PeriodoAporte!=0){
            if($FiltroFecha==2){
                $this->db->where('aporte.Anio = '.$PeriodoAporte);
            }else{
                $this->db->where('YEAR(aporte.FechaAcreditacion) = '.$PeriodoAporte);
            }

        }
        if ($MesAporte!=0){
            if($FiltroFecha==2){
                $this->db->where('aporte.Mes = '.$MesAporte);
            }else{
                $this->db->where('MONTH(aporte.FechaAcreditacion) = '.$MesAporte);

            }                
        }
        
        //$this->db->limit(100);
        if($FiltroFecha==2){
            $this->db->order_by("Anio desc, Mes desc");
        }else{
            $this->db->order_by("FechaAcreditacion desc");
        }
        $query = $this->db->get();
        //echo $this->db->last_query();
        return $query->result();
    }

    public function getAporte($IdAporte)
    {

        $this->db->select ('IdAporte, aporte.IdEmpresa, empresa.CUIT, empresa.Sucursal, RazonSocial, Anio, Mes, FechaDeposito, FechaAcreditacion, ImporteSindicato, ImporteFondoExtra, ImporteConvenio, ImporteEstimadoSindicato, ImporteEstimadoFondoExtra, ImporteEstimadoConvenio, ImporteOtro, DetalleOtro, DDJJ ');
        $this->db->from('aporte');
        $this->db->join('empresa', 'aporte.IdEmpresa = empresa.IdEmpresa');
       
        $this->db->where('IdAporte='.$IdAporte);
        $this->db->where('aporte.FechaBaja is null');
        $this->db->where('empresa.FechaBaja is null');
        
        $query = $this->db->get();
        return $query->result();
    }
    
    public function getMontosEstimados($IdEmpresaAporte, $anio, $mes){

       $query= $this->db->query("CALL calcularimportesestimados ($IdEmpresaAporte, $anio,$mes)");
       
       return $query->result();
       /* $this->db->select ('CONCAT_WS("", anioFinal, LPAD(mesFinal, 2, "0")) AS Cuota, ImporteSindicato, ImporteFondoExtra, ImporteConvenio');
        $this->db->from('tmpImportesEstimados');
        $this->db->where('mesFinal='.$mes);
        $this->db->where('anioFinal='.$anio);*/
       /* $query= $this->db->query("call calcularImportesEstimados2($IdEmpresaAporte, $anio, $mes, OUT porcen INT)");*/
        

        /*$this->db->select ('CONCAT_WS("", Anio, LPAD(Mes, 2, "0")) AS Cuota, ImporteSindicato, ImporteFondoExtra, ImporteConvenio');
        $this->db->from('aporte');
        $this->db->where('IdEmpresa='.$IdEmpresaAporte);
        $this->db->where('FechaBaja is null');
        $this->db->order_by("Cuota", "desc");
        $this->db->limit(1);*/
        /*$query = $this->db->get();
        echo $this->db->last_query();
        return $query->result();*/

    }


    public function getPeriodo()
    {
        $this->db->distinct();
        $this->db->select ('DISTINCT year(FechaAcreditacion) as Periodo');
        $this->db->from('aporte');
        /*$this->db->where('LEFT(cuota,4)>2005 AND LEFT(cuota,4)<=YEAR(NOW())');*/
        $this->db->where('FechaBaja is null');
        $this->db->order_by("Periodo", "desc");
        $query = $this->db->get();
        //echo $this->db->last_query();
        return $query->result();
    }

    public function getEmpresaId($IdEmpresa)
    {
        
        $this->db->select ('CUIT, Sucursal, RazonSocial');
        $this->db->from('empresa');
        $this->db->where('IdEmpresa = '.$IdEmpresa);
        $this->db->where('FechaBaja is null');
        $query = $this->db->get();
        return $query->result();
    }

    public function getEmpresaCUITSucursal($CUIT,$Sucursal)
    {
        
        $this->db->select ('IdEmpresa, RazonSocial');
        $this->db->from('empresa');
        $this->db->where('CUIT = "'.$CUIT.'" and Sucursal='.$Sucursal);
        $this->db->where('FechaBaja is null');
        $query = $this->db->get();
        return $query->result();
    }

    public function getTipoAporte()
    {
        
        $this->db->select ('CodTipoAporte, TipoAporte');
        $this->db->from('TipoAporte');
        $query = $this->db->get();
        return $query->result();
    }


    public function getEmpresaIdEmpresaAnioMes($IdEmpresa,$Anio,$Mes)
    {
        $res[0] = (object) array("IdAporte" => 0);
        $this->db->select ('IdAporte, Anio, Mes, FechaDeposito, ImporteSindicato, ImporteFondoExtra, ImporteConvenio');
        $this->db->from('aporte');
        $this->db->where('IdEmpresa = '.$IdEmpresa.' and Anio='.$Anio.' and Mes='.$Mes);
       // $this->db->where('IdEmpresa = 176 and Anio=2019 and Mes=8');
        
        $this->db->where('FechaBaja is null');
        $query = $this->db->get();
        if ($query->num_rows()==0){return $res;}else{
                    return $query->result();}

        /*print_r($res);*/
        //return $query->num_rows();
        //return $query->num_rows();

    }

    public function eliminarAporte($IdAporte, $IdUsuario)
    {   
        $Fecha = date('Y-m-d H:i');
        $this->db->set('FechaBaja', "'".$Fecha."'", FALSE);
        $this->db->set('IdUsuarioBaja', $IdUsuario, FALSE);
        echo $this->db->last_query();
        $this->db->where('IdAporte',$IdAporte);
        $str = $this->db->update('aporte');
        return $str;
    }

    public function grabarAporte($post)
    {   
        if($this->db->insert('aporte', $post)){//echo $this->db->last_query();
        return $this->db->insert_id();}

        return false;
    }

    public function editarAporte($post,$IdAporte)
    {   
        //$IdEmpresa=540;
        $this->db->where('IdAporte',$IdAporte);
        if($this->db->update('aporte', $post)){
            //echo $this->db->last_query();
            return $IdAporte;
        }
        echo $this->db->last_query();
        return 0;
    }    



 	/*public function getEmpresas($CodProvincia, $CodCCT,$IdEmpresa)
    {
        
        $this->db->select (' e.IdEmpresa, e.RazonSocial, e.CUIT, e.CodProvincia, e.CodDepartamento, e.CodLocalidad, e.Calle, e.NumeroCalle, e.Domicilio, e.FechaDeclaracionJurada, e.FechaIngreso, CodCCT, CodConvenio, Actividad, e.Observaciones, Telefono, TelefonoOtro, Opcion, NroEmp, Adherente, NroSindicato, NroFondo, NroTres, EstadoEmpresa, e.Email, e.CodigoPostal, Estudio, EstudioContacto, EstudioHorario, EstudioDireccion, EstudioTelefono, EstudioMail, Sucursal, e.Localidad, Lat, Lng, CCT, Baja, CUITEX, e.BajaObraSocial, e.Imprimir, Alias, MotivoBaja, e.FechaGrabacion, CUITalias, SinPersonal, DeclaracionJuradacuota, CodSindicato, CodFondo, CodUsufructo, CodOtros, Partido, IF(a.CUIT IS NULL, 0, COUNT(*)) AS CantAfiliados');
        $this->db->from('empresa AS e');
        $this->db->join('afiliado AS a', 'e.CUIT=a.CUIT', 'left');
        if ($IdEmpresa==0){
        
			$this->db->where('(e.CodProvincia = "'.$CodProvincia.'" or "'.$CodProvincia.'"=0) and  (CodCCT = "'.$CodCCT.'" or "'.$CodCCT.'"=0)');
		}else{
			$this->db->where('e.IdEmpresa = '.$IdEmpresa);
		}
        $this->db->group_by('IdEmpresa, RazonSocial, CUIT, CodProvincia, CodDepartamento, CodLocalidad, Calle, NumeroCalle, Domicilio, FechaDeclaracionJurada, FechaIngreso, CodCCT, CodConvenio, Actividad, Observaciones, Telefono, TelefonoOtro, Opcion, NroEmp, Adherente, NroSindicato, NroFondo, NroTres, EstadoEmpresa, Email, CodigoPostal, Estudio, EstudioContacto, EstudioHorario, EstudioDireccion, EstudioTelefono, EstudioMail, Sucursal, Localidad, Lat, Lng, CCT, Baja,CUITEX, BajaObraSocial, Imprimir, Alias, MotivoBaja, FechaGrabacion, CUITalias, SinPersonal, DeclaracionJuradacuota, CodSindicato, CodFondo, CodUsufructo, CodOtros, Partido'); 
        $query = $this->db->get();
        return $query->result();
    }

    public function add($post)
    {
        //pre($post);

        //$post = $this->cleanPostFields($post);

        //pre($post);

        if($this->db->insert('empresa', $post))
            return $this->db->insert_id();
        
        return false;
    }

    public function edit($post,$IdEmpresa)
    {   
        //$IdEmpresa=540;
        $this->db->where('IdEmpresa',$IdEmpresa);
        if($this->db->update('empresa', $post))
            return $IdEmpresa;

        return 0;
    }    */
}
