<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Hipoacusia_model extends CI_Model {


    /*
 	public function get($IdUsuarioCarga = null)
    {
        $this->db->select(implode(',',$this->fieldRealToTruncatedForSelect()));
        $this->db->from('dtahHipoacusia h');
        $this->db->join('dtahEstados e', 'h.IdEstado = e.IdEstado');
        
        if($IdUsuarioCarga)
            $this->db->where('h.IdUsuarioCarga', $IdUsuarioCarga);

        $this->db->order_by('h.IdHipoacusia','DESC');

        $query = $this->db->get();
        
        //pre($this->db->last_query());
        //pre(getTruncatedFieldFromReal('EvalPsicosocialRecomiendaImplante'));
        //pre(getRealFieldFromTruncated('EvalPsicosocialRecomiendaI_114'));
        
        return $query->result();
    }
    */

    public function get($IdUsuarioCarga = null)
    {
        $fields = implode(',',$this->fieldRealToTruncatedForSelect());

        $where = '';
        if($IdUsuarioCarga)
        {
            $where = "WHERE h.IdUsuarioCarga = {$IdUsuarioCarga} OR (h.IdHipoacusia IN (SELECT c.IdRelacion FROM Invitados c WHERE c.IdAplicativo = ".ID_APLICATIVO." AND c.IdUsuarioInvitado = {$IdUsuarioCarga}))";
        }

        $sql = "SELECT {$fields} FROM dtahHipoacusia h INNER JOIN dtahEstados e ON e.IdEstado = h.IdEstado {$where} ORDER BY h.IdHipoacusia DESC";

        $query = $this->db->query($sql);

        $r = $query->result();

        return $r;
    }

    public function getInvitadosFromUser($IdUsuario)
    {
        if(!$IdUsuario)
            return array();

        $this->db->select('c.*, u.Nombre as TitularNombre, u.Apellido as TitularApellido');
        $this->db->from('Invitados c');
        $this->db->join('Usuario u', 'u.IdUsuario = c.IdUsuarioTitular', 'left');
        $this->db->where('c.IdAplicativo', ID_APLICATIVO);
        $this->db->where('c.IdUsuarioInvitado', $IdUsuario);
        $this->db->order_by('c.IdRelacion');

        $query = $this->db->get();

        $r = $query->result();

        $arr = array();
        if($r)
        {
            foreach ($r as $k => $v)
            {
                // if(!array_key_exists($v->IdRelacion, $arr))
                //     $arr[$v->IdRelacion] = new StdClass;

                // array_push($arr[$v->IdRelacion], $v);
                $arr[$v->IdRelacion] = $v;
            }
        }

        return $arr;
    }

    public function getIndicadores($id_usuario_carga = null)
    {
        $this->db->select('a.Dato, e.Estado, COUNT(*) as Cantidad');
        $this->db->from('dtahHipoacusia h');
        $this->db->join('dtahEstados e', 'h.IdEstado = e.IdEstado');
        $this->db->join('dtahDatosAuxiliares a', 'a.IdUnico = h.QueSeAutoriza');
        
        if($id_usuario_carga)
            $this->db->where('h.IdUsuarioCarga', $id_usuario_carga);
        
        $this->db->group_by('e.Estado, a.Dato');
        $this->db->order_by('a.Dato, e.Estado');

        $query = $this->db->get();
        
        return $query->result();
    }

    public function getById($id_hipoacusia)
    {
        $this->db->select(implode(',',$this->fieldRealToTruncatedForSelect()) . ', ef1.CodProv as CodProv_FonoaudCodSISA7, ef2.CodProv as CodProv_RehabilitaAudCodSISA7, ef3.CodProv as CodProv_RehabilitaImpCodSISA7, ef4.CodProv as CodProv_ImplantaCodSISA7');
        
        $this->db->from('dtahHipoacusia h');
        $this->db->join('dtahEstados e', 'h.IdEstado = e.IdEstado');
        
        $this->db->join('Efector ef1', 'ef1.CodSISA7 = h.FonoaudCodSISA7', 'left');
        $this->db->join('Efector ef2', 'ef2.CodSISA7 = h.RehabilitaAudCodSISA7', 'left');
        $this->db->join('Efector ef3', 'ef3.CodSISA7 = h.RehabilitaImpCodSISA7', 'left');
        $this->db->join('Efector ef4', 'ef4.CodSISA7 = h.ImplantaCodSISA7', 'left');

        $this->db->where('h.IdHipoacusia', $id_hipoacusia);
        $this->db->limit(1);

        $query = $this->db->get();
        
        $result = $query->result();

        return ($result ? reset($result) : array());
    }

    public function add($post)
    {
        //pre($post);
        $post = $this->cleanPostFields($post);
        //pre($post);

        if($this->db->insert('dtahHipoacusia', $post))
            return $this->db->insert_id();
        
        return false;
    }

    public function replicar($id_hipoacusia, $target, $row)
    {
        $this->load->model('estado_model');

        $values = array();
        $exclude = array('h.IdHipoacusia');
        $replace = array(
            'h.IdHipoacusiaOrigen' => $id_hipoacusia,
            'h.QueSeAutoriza' => $target,
            'h.FechaAutorizacion' => date('Y-m-d'),
            'h.IdEstado' => Estado_model::INICIADO,
            'h.EstadoDetalle' => NULL,
            //'IdUsuarioCarga' => , no lo modifico para q si o si siga siendo del mismo owner del original
        );

        // IMPORTANTE deberia limpiar los campos q no le correspondan al nuevo target

        // arma arr con campos a insertar
        foreach ($row as $k => $v)
        {
            if(strpos($k, 'h_')===FALSE)
                continue; 

            if(strpos($k, 'h_') != 0)
                continue;

            $real = getRealFieldFromTruncated($k);

            if(in_array($real, $exclude))
                continue;

            //pre($k . ' - ' . $real);

            if(array_key_exists($real, $replace))
            {
                $values[$real] = $replace[$real];
            }
            else
            {
                $values[$real] = $v;
            } 
        }

        // pre($values);
        // die;

        if($this->db->insert('dtahHipoacusia', $values))
            return $this->db->insert_id();
        
        return false;
    }

    public function edit($post)
    {
        //pre($post);
        $id = $post['id_hipoacusia'];
        $post = $this->cleanPostFields($post);
        //pre($post);
        
        // los saco xq sino lo asigna con null
        unset($post['IdUsuarioCarga']);
        unset($post['IdHipoacusiaOrigen']);

        $this->db->where('IdHipoacusia', $id);
        
        if($this->db->update('dtahHipoacusia', $post))
            return $id;
        
        return false;
    }

    public function change_status($id, $id_estado, $detalle = null)
    {
        $this->db->where('IdHipoacusia', $id);
        
        $change = array();
        $change['IdEstado'] = $id_estado;

        if($detalle)
            $change['EstadoDetalle'] = $detalle;

        if($this->db->update('dtahHipoacusia', $change))
            return $id;
        
        return false;
    }

    public function cleanEstadoDetalle($id_hipoacusia)
    {
        $this->db->where('IdHipoacusia', $id_hipoacusia);
        
        $change = array();
        $change['EstadoDetalle'] = null;

        if($this->db->update('dtahHipoacusia', $change))
            return $id_hipoacusia;
        
        return false;
    }

    private function cleanPostFields($post)
    {
        unset($post['operation']);
        unset($post['id_hipoacusia']);
        unset($post['save']);

        foreach ($post as $k => $v)
        {
            if(strlen($v)===0)
                $post[$k] = null;
        }

        foreach ($this->getDbFieldName() as $k => $v)
        {
            if(strpos($v, 'h.')===false)
                continue;

            $v = str_replace('h.', '', $v);

            if($v=='IdHipoacusia')
                continue;

            if($v=='IdEstado')
                continue;

            if(!array_key_exists($v, $post))
                $post[$v] = null;
        }

        return $post;
    }

    public function getDbFieldName()
    {   
        return array(
             'h.IdHipoacusia'
            ,'h.IdHipoacusiaOrigen'
            ,'h.PacienteDocumento'
            ,'h.PacienteApellido'
            ,'h.PacienteNombre'
            ,'h.FechaNacimiento'
            ,'h.PacienteCodProv'
            ,'h.PacienteDepart'
            ,'h.CodSISA7nacimiento'
            ,'h.PacienteCiudad'
            ,'h.PacienteCodigoPostal'
            ,'h.PacienteDomicilio'
            ,'h.PacienteGenero'
            ,'h.MadreApellido'
            ,'h.MadreNombre'
            ,'h.MadreNroDocumento'
            ,'h.MadreCelular'
            ,'h.PadreApellido'
            ,'h.PadreNombre'
            ,'h.PadreNroDocumento'
            ,'h.PadreCelular'
            ,'h.EncargadoApellido'
            ,'h.EncargadoNombre'
            ,'h.EncargadoNroDocumento'
            ,'h.EncargadoCelular'
            ,'h.SolicitaAudifonos'
            ,'h.FechaSolicitudAudifonos'
            ,'h.FonoaudApellido'
            ,'h.FonoaudNombre'
            ,'h.FonoaudCodSISA7'
            ,'h.RehabilitaAudApellido'
            ,'h.RehabilitaAudNombre'
            ,'h.RehabilitaAudCodProfesion'
            ,'h.RehabilitaAudCodSISA7'
            ,'h.SolicitaImplantes'
            ,'h.FechaSolicitudImplantes'
            ,'h.MarcayModeloAudifonos'
            ,'h.DesdeCuandoUsaAudifonos'
            ,'h.RehabilitaImpCodSISA7'
            ,'h.RehabilitaImpApellido'
            ,'h.RehabilitaImpNombre'
            ,'h.RehabilitaImpCodProfesion'
            ,'h.ImplantaApellido'
            ,'h.ImplantaNombre'
            ,'h.ImplantaMatricula'
            ,'h.ImplantaCodSISA7'
            ,'h.ImplantaDomicilio'
            ,'h.ImplantaTelefono'
            ,'h.TORSCH'
            ,'h.DetalleTORSCH'
            ,'h.HIV'
            ,'h.MalformacionesCraneofaciales'
            ,'h.DetalleMalformacionesCraneofaciales'
            ,'h.AntecedentesFamiliaresHipoacusia'
            ,'h.EdadGestacional'
            ,'h.PesoAlNacer'
            ,'h.TipoParto'
            ,'h.Apgar1erMinuto'
            ,'h.Apgar5toMinuto'
            ,'h.Apgar10moMinuto'
            ,'h.RequirioRCP'
            ,'h.Meningitis'
            ,'h.AfeccionesNeurologicas'
            ,'h.MedicacionOtotoxica'
            ,'h.MedicacionOtotoxicaCual'
            ,'h.MedicacionOtotoxicaDias'
            ,'h.RetrasoDelLenguaje'
            ,'h.OtitisMediaCronicaoRecidivante'
            ,'h.Hipotermia'
            ,'h.HipotermiaHoras'
            ,'h.ARM'
            ,'h.DiasExposicionARM'
            ,'h.Cipap'
            ,'h.DiasCipap'
            ,'h.Surfactante'
            ,'h.DosisSurfactante'
            ,'h.OtraAlteracionRespiratoria'
            ,'h.DetalleOtraAlteracionRespiratoria'
            ,'h.DiasOtraAlteracionRespiratoria'
            ,'h.Hiperbillirrubinemia'
            ,'h.Luminoterapia'
            ,'h.DiasExposicionLuminoterapia'
            ,'h.OEA1OD'
            ,'h.OEA1OI'
            ,'h.OEA1fecha'
            ,'h.OEA2OD'
            ,'h.OEA2OI'
            ,'h.OEA2fecha'
            ,'h.OEAABROD'
            ,'h.OEAABROI'
            ,'h.OEAABRfecha'
            ,'h.FechaTimpanooImpedanciometria'
            ,'h.TipoDeCurvaToI'
            ,'h.BERAfecha'
            ,'h.BERAonda1OD'
            ,'h.BERAonda1OI'
            ,'h.BERAonda2OD'
            ,'h.BERAonda2OI'
            ,'h.BERAonda3OD'
            ,'h.BERAonda3OI'
            ,'h.BERAonda4OD'
            ,'h.BERAonda4OI'
            ,'h.BERAonda5OD'
            ,'h.BERAonda5OI'
            ,'h.BERAinforme'
            ,'h.AudiometriaTonal'
            ,'h.AudiometriaACampoLibre'
            ,'h.PruebasSubjetivas'
            ,'h.PruebasSubjetivasResultado'
            ,'h.DiagnosticoxImagen'
            ,'h.TomografiaComputada'
            ,'h.FechaDxIoTC'
            ,'h.InformeDxIoTC'
            ,'h.ResonanciaMagnetica'
            ,'h.FechaRMN'
            ,'h.InformeRMN'
            ,'h.EvalPsicosocialApellido'
            ,'h.EvalPsicosocialNombre'
            ,'h.EvalPsicosocialCodProfesion'
            ,'h.EvaluacionPsicosocial'
            ,'h.EvalPsicosocialRecomiendaImplante'
            ,'h.EvaluacionVestibular'
            ,'h.EvalVestibularRecomiendaImplante'
            ,'h.PoseeObraSocial'
            ,'h.PoseeObraSocialDetalle'
            ,'h.FechaPoseeObraSocial'
            ,'h.QueSeAutoriza'
            ,'h.FechaAutorizacion'
            ,'h.IdEstado'
            ,'h.EstadoDetalle'
            ,'h.IdUsuarioCarga'
            ,'e.Estado'
            ,'e.Comentario'
        );
    }

    // public function getDbFieldName()
    // {   
    //     return array(
    //          'h.IdHipoacusia' => 'ID Hipoacusia',
    //         ,'h.IdHipoacusiaOrigen' => 'ID Hipoacusia original',
    //         ,'h.PacienteDocumento' => 'Nro. Documento del paciente',
    //         ,'h.PacienteApellido' => 'Apellido del paciente',
    //         ,'h.PacienteNombre' => 'Nombre del paciente',
    //         ,'h.FechaNacimiento' => 'Fecha nacimiento del paciente',
    //         ,'h.PacienteCodProv' => 'Cod. Provincia del paciente',
    //         ,'h.PacienteDepart' => 'Cod. Departamento del paciente',
    //         ,'h.CodSISA7nacimiento' => 'Cod. Efector de nacimiento del paciente',
    //         ,'h.PacienteCiudad' => 'Ciudad del paciente',
    //         ,'h.PacienteCodigoPostal' => 'Cod. Postal del paciente',
    //         ,'h.PacienteDomicilio' => 'Domicilio del paciente',
    //         ,'h.PacienteGenero' => 'Género del paciente',
    //         ,'h.MadreApellido' => 'Apellido de la madre',
    //         ,'h.MadreNombre' => 'Nombre de la madre',
    //         ,'h.MadreNroDocumento' => 'Nro. Documento de la madre',
    //         ,'h.MadreCelular' => 'Nro. Celular de la madre',
    //         ,'h.PadreApellido' => 'Apellido del padre',
    //         ,'h.PadreNombre' => 'Nombre del padre',
    //         ,'h.PadreNroDocumento' => 'Nro. Documento del padre',
    //         ,'h.PadreCelular' => 'Nro. Celular del padre',
    //         ,'h.EncargadoApellido' => 'Apellido del tutor',
    //         ,'h.EncargadoNombre' => 'Nombre del tutor ',
    //         ,'h.EncargadoNroDocumento' => 'Nro. Documento del tutor',
    //         ,'h.EncargadoCelular' => 'Nro. Celular del tutor',
    //         ,'h.SolicitaAudifonos' => 'Solicita audífonos',
    //         ,'h.FechaSolicitudAudifonos' => 'Fecha',
    //         ,'h.FonoaudApellido' => '',
    //         ,'h.FonoaudNombre' => '',
    //         ,'h.FonoaudCodSISA7' => '',
    //         ,'h.RehabilitaAudApellido' => '',
    //         ,'h.RehabilitaAudNombre' => '',
    //         ,'h.RehabilitaAudCodProfesion' => '',
    //         ,'h.RehabilitaAudCodSISA7' => '',
    //         ,'h.SolicitaImplantes' => '',
    //         ,'h.FechaSolicitudImplantes' => '',
    //         ,'h.MarcayModeloAudifonos' => '',
    //         ,'h.DesdeCuandoUsaAudifonos' => '',
    //         ,'h.RehabilitaImpCodSISA7' => '',
    //         ,'h.RehabilitaImpApellido' => '',
    //         ,'h.RehabilitaImpNombre' => '',
    //         ,'h.RehabilitaImpCodProfesion' => '',
    //         ,'h.ImplantaApellido' => '',
    //         ,'h.ImplantaNombre' => '',
    //         ,'h.ImplantaMatricula' => '',
    //         ,'h.ImplantaCodSISA7' => '',
    //         ,'h.ImplantaDomicilio' => '',
    //         ,'h.ImplantaTelefono' => '',
    //         ,'h.TORSCH' => '',
    //         ,'h.DetalleTORSCH' => '',
    //         ,'h.HIV' => '',
    //         ,'h.MalformacionesCraneofaciales' => '',
    //         ,'h.DetalleMalformacionesCraneofaciales' => '',
    //         ,'h.AntecedentesFamiliaresHipoacusia' => '',
    //         ,'h.EdadGestacional' => '',
    //         ,'h.PesoAlNacer' => '',
    //         ,'h.TipoParto' => '',
    //         ,'h.Apgar1erMinuto' => '',
    //         ,'h.Apgar5toMinuto' => '',
    //         ,'h.Apgar10moMinuto' => '',
    //         ,'h.RequirioRCP' => '',
    //         ,'h.Meningitis' => '',
    //         ,'h.AfeccionesNeurologicas' => '',
    //         ,'h.MedicacionOtotoxica' => '',
    //         ,'h.MedicacionOtotoxicaCual' => '',
    //         ,'h.MedicacionOtotoxicaDias' => '',
    //         ,'h.RetrasoDelLenguaje' => '',
    //         ,'h.OtitisMediaCronicaoRecidivante' => '',
    //         ,'h.Hipotermia' => '',
    //         ,'h.HipotermiaHoras' => '',
    //         ,'h.ARM' => '',
    //         ,'h.DiasExposicionARM' => '',
    //         ,'h.Cipap' => '',
    //         ,'h.DiasCipap' => '',
    //         ,'h.Surfactante' => '',
    //         ,'h.DosisSurfactante' => '',
    //         ,'h.OtraAlteracionRespiratoria' => '',
    //         ,'h.DetalleOtraAlteracionRespiratoria' => '',
    //         ,'h.DiasOtraAlteracionRespiratoria' => '',
    //         ,'h.Hiperbillirrubinemia' => '',
    //         ,'h.Luminoterapia' => '',
    //         ,'h.DiasExposicionLuminoterapia' => '',
    //         ,'h.OEA1OD' => '',
    //         ,'h.OEA1OI' => '',
    //         ,'h.OEA1fecha' => '',
    //         ,'h.OEA2OD' => '',
    //         ,'h.OEA2OI' => '',
    //         ,'h.OEA2fecha' => '',
    //         ,'h.OEAABROD' => '',
    //         ,'h.OEAABROI' => '',
    //         ,'h.OEAABRfecha' => '',
    //         ,'h.FechaTimpanooImpedanciometria' => '',
    //         ,'h.TipoDeCurvaToI' => '',
    //         ,'h.BERAfecha' => '',
    //         ,'h.BERAonda1OD' => '',
    //         ,'h.BERAonda1OI' => '',
    //         ,'h.BERAonda2OD' => '',
    //         ,'h.BERAonda2OI' => '',
    //         ,'h.BERAonda3OD' => '',
    //         ,'h.BERAonda3OI' => '',
    //         ,'h.BERAonda4OD' => '',
    //         ,'h.BERAonda4OI' => '',
    //         ,'h.BERAonda5OD' => '',
    //         ,'h.BERAonda5OI' => '',
    //         ,'h.BERAinforme' => '',
    //         ,'h.AudiometriaTonal' => '',
    //         ,'h.AudiometriaACampoLibre' => '',
    //         ,'h.PruebasSubjetivas' => '',
    //         ,'h.PruebasSubjetivasResultado' => '',
    //         ,'h.DiagnosticoxImagen' => '',
    //         ,'h.TomografiaComputada' => '',
    //         ,'h.FechaDxIoTC' => '',
    //         ,'h.InformeDxIoTC' => '',
    //         ,'h.ResonanciaMagnetica' => '',
    //         ,'h.FechaRMN' => '',
    //         ,'h.InformeRMN' => '',
    //         ,'h.EvalPsicosocialApellido' => '',
    //         ,'h.EvalPsicosocialNombre' => '',
    //         ,'h.EvalPsicosocialCodProfesion' => '',
    //         ,'h.EvaluacionPsicosocial' => '',
    //         ,'h.EvalPsicosocialRecomiendaImplante' => '',
    //         ,'h.EvaluacionVestibular' => '',
    //         ,'h.EvalVestibularRecomiendaImplante' => '',
    //         ,'h.PoseeObraSocial' => '',
    //         ,'h.PoseeObraSocialDetalle' => '',
    //         ,'h.FechaPoseeObraSocial' => '',
    //         ,'h.QueSeAutoriza' => '',
    //         ,'h.FechaAutorizacion' => '',
    //         ,'h.IdEstado' => '',
    //         ,'h.EstadoDetalle' => '',
    //         ,'h.IdUsuarioCarga' => '',
    //         ,'e.Estado' => '',
    //         ,'e.Comentario' => '',
    //     );
    // }


    public function arrayFieldRealToTruncated()
    {
        $db_fields = $this->getDbFieldName();
        $new = array();
        $cont = 0;
        foreach ($db_fields as $k => $v)
        {
            $cont++;
            $new[$v] = substr(str_replace('.','_',$v),0,22) . '_' . $cont;
        }

        return $new;
    }

    public function arrayFieldTruncatedToReal()
    {
        $db_fields = $this->getDbFieldName();
        $new = array();
        $cont = 0;
        foreach ($db_fields as $k => $v)
        {
            $cont++;
            $new[$v] = substr(str_replace('.','_',$v),0,22) . '_' . $cont;
        }

        $new_flip = array_flip($new);

        return $new_flip;
    }

    private function fieldRealToTruncatedForSelect()
    {
        $db_fields = $this->getDbFieldName();
        $new = array();
        $cont = 0;
        foreach ($db_fields as $k => $v)
        {
            $cont++;
            $new[$v] = $v . ' as ' . substr(str_replace('.','_',$v),0,22) . '_' . $cont; // . ','
        }

        return $new;
    }

}

