<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Cct extends CI_Controller {

    public function __construct()
    {
        parent::__construct();
        
       /* if(is_null($this->session->userdata('logged_in')))
            redirect('login');*/

        $this->section = 'CCT';
    }

    public function index()
    {
        try {

            //Permission::check(__METHOD__);

            if(is_null($this->session->userdata('usuario')))
            redirect('login');

            $this->load->model('CCT_model');
            $data['result']=$this->CCT_model->getCCT(-1);

            $data['content'] = $this->load->view('cct/grilla', $data, true);
            $this->load->view('template', $data);

        } catch (Exception $e) {
            go_error($e);
        }
    }

    public function getCodCCT()
    {
        try {
                $this->load->model('CCT_model');
                $cantAporte=0;
        
                if (trim($_POST['CodCCT'])){
            
                    $cantCCT= $this->CCT_model->getCodCCT($_POST['CodCCT']);
                }
        
                if($cantCCT == 0)
                {
                    $json['valid'] = true;
                }
                else
                {
                    $json['valid'] = false;
                }

                echo json_encode($json);

            } catch (Exception $e) {
            go_error($e);
        }
    }

    public function mostrarConvenio($CodCCT = 0){
            
        if(is_null($this->session->userdata('usuario')))
        redirect('login');

        $this->load->model('CCT_model');

        $data['result']=$this->CCT_model->mostrarConvenio($CodCCT);
        $data['result']=$this->CCT_model->getCCT(-1);

        $data['content'] = $this->load->view('cct/grilla', $data, true);
        $this->load->view('template', $data);    

    }

    
    public function nuevoConvenio($CodCCT = 0){
        try {

            if(is_null($this->session->userdata('usuario'))) redirect('login');

            $this->load->model('CCT_model');
            $data['result'] = $this->CCT_model->getunCodCCT($CodCCT);
            $data['operation'] = 'nuevo';
            $data['title'] = 'Nuevo CCT';
            $data['content'] = $this->load->view('cct/formNuevoConvenio', $data, true);

            $this->load->view('template', $data);

        } catch (Exception $e) {
            go_error($e);
        }
    }


    public function listarConvenio($CodCCT){
        try {
            
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            

            $this->load->model('CCT_model');
            $arr="";
            $var_data= $this->CCT_model->getunCodCCT($CodCCT);

            foreach($var_data as $row) {
                $arr[] = array($row->NumConvenio, $row->Porcentaje,$row->FechaDesde);
            }

            echo json_encode($arr);

        } catch (Exception $e) {
            go_error($e);
        }
    }            


    public function eliminarCCT($CodCCT){
        try {
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            
            $this->load->model('CCT_model');
           

            $var_data=$this->CCT_model->eliminarCCT($CodCCT, $this->session->userdata('IdUsuario'));
            
            add_log('Eliminar', 'CCT', $CodCCT);
            //echo json_encode($var_data);
            redirect(base_url('index.php/Cct/'));

        } catch (Exception $e) {
            go_error($e);
        }
    }

    public function eliminarConvenio($IdCctConvenio = 0, $CodCCT){
        try {
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            $this->load->model('CCT_model');
           

            $var_data=$this->CCT_model->eliminarConvenio($IdCctConvenio, $this->session->userdata('IdUsuario'));
            
            add_log('Eliminar', 'Convenio', $IdCctConvenio);
            //echo json_encode($var_data);
            redirect(base_url('index.php/Cct/nuevoConvenio/'.$CodCCT));

        } catch (Exception $e) {
            go_error($e);
        }
    }

    public function add()
    {
        try {
            if(is_null($this->session->userdata('usuario'))) redirect('login');
           
            $data['row'] = null;
            $data['operation'] = 'add';
            $data['title'] = 'Nuevo CCT';
            $data['content'] = $this->load->view('cct/form', $data, true);

            add_log('Usuarios - Add');

            $this->load->view('template', $data);

        } catch (Exception $e) {
            go_error($e);
        }
    }


    public function grabarCCT(){
        
        if(is_null($this->session->userdata('usuario'))) redirect('login');
        $result = array();

        $this->load->model('CCT_model');

        $post = $this->input->post();

        if($this->input->post())
            {
                if($this->input->post('operation')=='add')
                {
                    unset($post['operation']);
                    $CodCCT=0;
                    $post['IdUsuarioAlta']=$this->session->userdata('IdUsuario');
                    $post['FechaAlta']=date('Y-m-d H:i');
                    $CodCCT = $this->CCT_model->grabarCCT($post);

                    if($CodCCT==0) echo json_encode(array("CodCCT" => 0));
                    else{
                        $result[] = array("CodCCT" => $CodCCT);
                        add_log('Nuevo', 'CCT', $CodCCT);
                        echo json_encode($result);
                    }
            }
            // update record
            elseif($this->input->post('operation')=='edit')
                {
               
                }
            }
    }


    public function grabarCCTconvenio(){

        if(is_null($this->session->userdata('usuario'))) redirect('login');
        $result = array();

        $this->load->model('CCT_model');

        $post = $this->input->post();

        if($this->input->post())
            {
                
                    $CodCCT=$post['CodCCT'];
                    unset($post['operation']);
                    unset($post['CCT']);
                    unset($post['save']);
                    $post['IdUsuarioAlta']=$this->session->userdata('IdUsuario');
                    $post['FechaAlta']=date('Y-m-d H:i');                    

                    $IdCctConvenio = $this->CCT_model->grabarCCTconvenio($post);
                    if($IdCctConvenio==0) echo json_encode(array("IdCctConvenio" => 0));
                    
                    $result[] = array("CodCCT" => $CodCCT, "IdCctConvenio" => $IdCctConvenio);
                    add_log('Nuevo', 'Convenio', $IdCctConvenio);
                    echo json_encode($result);
             }       
    }
}   

