<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Cctcategorias extends CI_Controller {

    public function __construct()
    {
        parent::__construct();
        
       /* if(is_null($this->session->userdata('logged_in')))
            redirect('login');*/

        $this->section = 'CCTcategorias';
    }

    public function index($CodCCT = -1)
    {
        try {

            Permission::check(__METHOD__);

            if(is_null($this->session->userdata('usuario')))
            redirect('login');

            $this->load->model('CCTcategorias_model');
            $data['CodCCT']=$CodCCT;
            $data['resultCCT']=$this->CCTcategorias_model->getCCT($CodCCT);

            //$data['result']=$this->CCTcategorias_model->getCCTcategorias($CodCCT);
            $data['content'] = $this->load->view('cct/cctcategorias/grillaCCTcategorias', $data, true);
            $this->load->view('template', $data);

        } catch (Exception $e) {
            go_error($e);
        }
    }

    public function mostrarCategorias($CodCCT = -1){
            
        if(is_null($this->session->userdata('usuario')))
            redirect('login');
        try {
            //Permission::check(__METHOD__);

            $this->load->model('CCTcategorias_model');
                $arr="";
        
                $var_data= $this->CCTcategorias_model->getCCTcategorias($CodCCT);
                
        
                foreach($var_data as $row) {
                        
                $html2='<div class="btn-group">';
                $html2.='<a title="Ver Sueldos"> <button type="button" class="btn btn-primary btn-xs verSueldosBasicosCategorias" data-id="'.$row->IdCategoria.'" style="margin-right:16px;"><span class="glyphicon glyphicon-list" aria-hidden="true"> </span></button> </a>';



                $html2.='<a title="Ver/Editar" href="'.base_url("index.php/Cctcategorias/add/$CodCCT/$row->IdCategoria").'"> <button type="button" class="btn btn-primary btn-xs dt-editarCategoria" style="margin-right:16px;"><span class="glyphicon glyphicon-edit" aria-hidden="true"></span></button> </a>';
                $html2.='<a title="Eliminar" href="'.base_url("index.php/Cctcategorias/eliminarCategoria/$CodCCT/$row->IdCategoria").'"> <button type="button" class="btn btn-danger btn-xs dt-eliminarCategoria" style="margin-right:16px;"><span class="glyphicon glyphicon-remove glyphicon-trash" aria-hidden="true"></span></button> </a>';
                
                $html2.='</div>';


                        $arr[] = array($row->IdCategoria, $row->Categoria, $html2);
                        
                }
                echo json_encode($arr);
        } catch (Exception $e) {
            go_error($e);
        }


    }

    
    public function getCategoriaSueldos($IdCategoria){
        try {
            
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            

            $this->load->model('CCTcategorias_model');
            
            $var_data= $this->CCTcategorias_model->getCategoriaSueldos($IdCategoria);

            foreach($var_data as $row) {
                $tmp['Categoria']=$row->Categoria;
                $tmp['IdCategoria']=$IdCategoria;
                $arr[]=$tmp;
                
            }
            

            echo json_encode($arr);

        } catch (Exception $e) {
            go_error($e);
        }
    }   

    public function getListadoCategoriaSueldos($IdCategoria){
        try {
            
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            //Permission::check(__METHOD__);
            $arrCat="";
            $this->load->model('CCTcategorias_model');
            
            $var_data= $this->CCTcategorias_model->getListadoCategoriaSueldos($IdCategoria);

            foreach($var_data as $row) {
                $arrCat[]= array($row->IdCategoria,$row->SueldoBasicoCategoria, $row->FechaDesdeSueldoCategoria,$row->FechaHastaSueldoCategoria);
                
            }
            

            echo json_encode($arrCat);

        } catch (Exception $e) {
            go_error($e);
        }
    }   
    /*public function listarCategorias($CodCCT){
        try {
            
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            

            $this->load->model('CCTcategorias_model');
            $arr="";
            $var_data= $this->CCT_model->getunCodCCTcategoria($CodCCT);

            foreach($var_data as $row) {
                $arr[] = array($row->CodCCT, $row->Categoria);
            }

            echo json_encode($arr);

        } catch (Exception $e) {
            go_error($e);
        }
    }            
*/

    public function add($CodCCT, $IdCategoria=0)
    {
        try {
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            Permission::check(__METHOD__);
            
                $this->load->model('CCTcategorias_model');
            
                $var_data=$this->CCTcategorias_model->getUnCCT($CodCCT);
                foreach($var_data as $row) {
                    $data['Convenio'] = $row->CCT;
                }
            if ($IdCategoria==0){
                $data['row'] = null;
                $data['IdCategoria'] = null;
                $data['Categoria'] = null;
                $data['operation'] = 'add';
                $data['title'] = 'Nueva Categoria de: ';
                $data['CodCCT']=$CodCCT;
                $data['content'] = $this->load->view('cct/cctcategorias/form', $data, true);

                add_log('Categorias - Add');

                $this->load->view('template', $data);
            }else{
                $this->load->model('CCTcategorias_model');
                $data['IdCategoria'] = $IdCategoria;
                $var_data=$this->CCTcategorias_model->getCCTcategorias($CodCCT,$IdCategoria);
                foreach($var_data as $row) {
                    $data['Categoria'] = $row->Categoria;
                }

                $data['operation'] = 'edit';
                $data['title'] = 'Editar Categoria de: ';
                $data['CodCCT']=$CodCCT;
                $data['content'] = $this->load->view('cct/cctcategorias/form', $data, true);
                add_log('Categorias - Edit');

                $this->load->view('template', $data);
            }                

        } catch (Exception $e) {
            go_error($e);
        }
    }


    public function grabarCategoria(){
        
        if(is_null($this->session->userdata('usuario'))) redirect('login');
            
        try {
            Permission::check(__METHOD__);
        $result = array();

        $this->load->model('CCTcategorias_model');

        $post = $this->input->post();

        if($this->input->post())
            {
                if($this->input->post('operation')=='add')
                {
                    unset($post['operation']);
                    unset($post['save']);
                    //$CodCCT=0;
                    /*$post['IdUsuarioAlta']=$this->session->userdata('IdUsuario');
                    $post['FechaAlta']=date('Y-m-d H:i');*/
                    $IdCategoria = $this->CCTcategorias_model->grabarCCTcategoria($post);

                    if($IdCategoria==0) echo json_encode(array("IdCategoria" => 0));
                    else{
                        /*$result[] = array("CodCCT" => $CodCCT);*/
                        add_log('Nuevo', 'Categoria', $CodCCT);
                        redirect(base_url('index.php/cctcategorias/index/'.$post['CodCCT']));
                        //echo json_encode($result);
                    }
            }
            // update record
            elseif($this->input->post('operation')=='edit')
                {
                     $var_data=$this->CCTcategorias_model->updateCategoria($post['IdCategoria'], $this->session->userdata('IdUsuario'), $post['Categoria']);
            
                    add_log('Editar', 'Categoria', $IdCategoria);
            
                    redirect(base_url('index.php/cctcategorias/index/'.$post['CodCCT']));
                }
            }
        } catch (Exception $e) {
            go_error($e);
        }

    }

    public function eliminarCategoria($CodCCT, $IdCategoria){
        if(is_null($this->session->userdata('usuario')))
            redirect('login');
        try {

            Permission::check(__METHOD__);
            $this->load->model('CCTcategorias_model');
            //$var_data=$this->CCT_model->eliminarCategoria($IdCctConvenio, $this->session->userdata('IdUsuario'));
            $var_data=$this->CCTcategorias_model->eliminarCategoria($IdCategoria, $this->session->userdata('IdUsuario'));
            
            add_log('Eliminar', 'Categoria', $IdCategoria);
            
            redirect(base_url('index.php/cctcategorias/index/'.$CodCCT));

        } catch (Exception $e) {
            go_error($e);
        }
    }

    public function grabarSueldoBasicoCategoria(){
        
        if(is_null($this->session->userdata('usuario')))
            redirect('login');
        try {
            //Permission::check(__METHOD__);
              
            $result = array();

            $this->load->model('CCTcategorias_model');

            $post = $this->input->post();

            if($this->input->post())
            {
                if($this->input->post('SueldoBasicoCategoriaOperacion')=='add')
                {
                    unset($post['SueldoBasicoCategoriaOperacion']);
                    if (empty($post['FechaHastaSueldoCategoria'])){
                        $post['FechaHastaSueldoCategoria']='2030-12-31';
                    }

                    $post['IdCategoria']=$post['IdCategoriaSueldo'];
                    unset($post['IdCategoriaSueldo']);
                    $post['IdUsuarioAlta']=$this->session->userdata('IdUsuario');
                    $post['FechaAlta']=date('Y-m-d H:i');
                    $IdCategoria = $this->CCTcategorias_model->grabarSueldoBasicoCategoria($post);

                    if($IdCategoria==0) echo json_encode(array("IdCategoria" => 0));
                    else{
                        $result[] = array("IdCategoria" => $post['IdCategoria']);
                        add_log('Alta', 'CategoriaSueldo', $IdCategoria);
                        echo json_encode($result);
                        
                    }
            }
            // update record
            elseif($this->input->post('SueldoBasicoCategoriaOperacion')=='edit')
                { 
                    $post['IdCategoria']=$post['IdCategoriaSueldo'];
                    $var_data=$this->CCTcategorias_model->updateSueldoBasicoCategoria($post['IdCategoria'], $post['SueldoBasicoCategoria'], $post['FechaDesdeSueldoCategoria'], $post['FechaHastaSueldoCategoria']);

                    
                    $result[] = array("IdCategoria" => $post['IdCategoria']);
                    add_log('Editar', 'Categoria', $post['IdCategoria']);
                    echo json_encode($result);
                    
                }
            }
            } catch (Exception $e) {
                $result[] = array("SueldoBasico" => $e->getMessage());
                echo json_encode($result);
            
        }
    }

    public function eliminarSueldoBasicoCategoria($IdCategoriaSueldoBasico, $FechaDesdeSueldoBasicoCategoria){


        if(is_null($this->session->userdata('usuario')))
            redirect('login');
        try {
            Permission::check(__METHOD__);
            $result = array();
            $this->load->model('CCTcategorias_model');
            $var_dataSueldo= $this->CCTcategorias_model->eliminarSueldoBasicoCategoria($IdCategoriaSueldoBasico, $FechaDesdeSueldoBasicoCategoria);
            echo json_encode($var_dataSueldo);
        } catch (Exception $e) {
                $result[] = array("SueldoBasico" => $e->getMessage());
                echo json_encode($result);
            
        }
    }




/*    public function getCodCCT()
    {
        try {
                $this->load->model('CCT_model');
                $cantAporte=0;
        
                if (trim($_POST['CodCCT'])){
            
                    $cantCCT= $this->CCT_model->getCodCCT($_POST['CodCCT']);
                }
        
                if($cantCCT == 0)
                {
                    $json['valid'] = true;
                }
                else
                {
                    $json['valid'] = false;
                }

                echo json_encode($json);

            } catch (Exception $e) {
            go_error($e);
        }
    }*/

    /*public function mostrarConvenio($CodCCT = 0){
            
        if(is_null($this->session->userdata('usuario')))
        redirect('login');

        $this->load->model('CCT_model');

        $data['result']=$this->CCT_model->mostrarConvenio($CodCCT);
        $data['result']=$this->CCT_model->getCCT(-1);

        $data['content'] = $this->load->view('cct/grilla', $data, true);
        $this->load->view('template', $data);    

    }

    
    public function nuevoConvenio($CodCCT = 0){
        try {

            if(is_null($this->session->userdata('usuario'))) redirect('login');

            $this->load->model('CCT_model');
            $data['result'] = $this->CCT_model->getunCodCCT($CodCCT);
            $data['operation'] = 'nuevo';
            $data['title'] = 'Nuevo CCT';
            $data['content'] = $this->load->view('cct/formNuevoConvenio', $data, true);

            $this->load->view('template', $data);

        } catch (Exception $e) {
            go_error($e);
        }
    }*/


    


    /*public function eliminarCCT($CodCCT){
        try {
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            
            $this->load->model('CCT_model');
           

            $var_data=$this->CCT_model->eliminarCCT($CodCCT, $this->session->userdata('IdUsuario'));
            
            add_log('Eliminar', 'CCT', $CodCCT);
    
            redirect(base_url('index.php/Cct/'));

        } catch (Exception $e) {
            go_error($e);
        }
    }

    public function eliminarCategoria($IdCctConvenio = 0, $CodCCT){
        try {
            if(is_null($this->session->userdata('usuario'))) redirect('login');
            $this->load->model('CCT_model');
           

            $var_data=$this->CCT_model->eliminarConvenio($IdCctConvenio, $this->session->userdata('IdUsuario'));
            
            add_log('Eliminar', 'Convenio', $IdCctConvenio);
            
            redirect(base_url('index.php/Cct/nuevoConvenio/'.$CodCCT));

        } catch (Exception $e) {
            go_error($e);
        }
    }*/

    

    

    /*public function grabarCCTconvenio(){

        if(is_null($this->session->userdata('usuario'))) redirect('login');
        $result = array();

        $this->load->model('CCT_model');

        $post = $this->input->post();

        if($this->input->post())
            {
                
                    $CodCCT=$post['CodCCT'];
                    unset($post['operation']);
                    unset($post['CCT']);
                    unset($post['save']);
                    $post['IdUsuarioAlta']=$this->session->userdata('IdUsuario');
                    $post['FechaAlta']=date('Y-m-d H:i');                    

                    $IdCctConvenio = $this->CCT_model->grabarCCTconvenio($post);
                    if($IdCctConvenio==0) echo json_encode(array("IdCctConvenio" => 0));
                    
                    $result[] = array("CodCCT" => $CodCCT, "IdCctConvenio" => $IdCctConvenio);
                    add_log('Nuevo', 'Convenio', $IdCctConvenio);
                    echo json_encode($result);
             }       
    }*/
}   

