<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Cctsueldos extends CI_Controller {

    public function __construct()
    {
        parent::__construct();
        
       /* if(is_null($this->session->userdata('logged_in')))
            redirect('login');*/

        $this->section = 'CCTsueldos';
    }

    public function index($CodCCT = -1)
    {
        try {

            Permission::check(__METHOD__);

            if(is_null($this->session->userdata('usuario')))
            redirect('login');

            $this->load->model('CCTcategorias_model');
            $data['CodCCT']=$CodCCT;
            $data['resultCCT']=$this->CCTcategorias_model->getCCT($CodCCT);

            $data['content'] = $this->load->view('cct/cctsueldos/grillaCCTsueldos', $data, true);
            $this->load->view('template', $data);

        } catch (Exception $e) {
            go_error($e);
        }
    }

    public function mostrarCategorias($CodCCT = -1){
        if(is_null($this->session->userdata('usuario')))
            redirect('login');
        try {   
                
                $this->load->model('CCTcategorias_model');
                $arr="";
        
                $var_data= $this->CCTcategorias_model->getCCTcategorias($CodCCT);
                foreach($var_data as $row) {
                    $tmp['IdCategoria']=$row->IdCategoria;
                    $tmp['Categoria']=$row->Categoria;
                    $arr[]=$tmp;
                }
            

                echo json_encode($arr);
                
            }catch (Exception $e) {
                go_error($e);
        }



    }   

    public function mostrarAdicionales($CodCCT = -1){
        if(is_null($this->session->userdata('usuario')))
            redirect('login');
        try {   
                
                $this->load->model('CCTcategorias_model');
                $arr="";
        
                $var_data= $this->CCTcategorias_model->getCCTadicionales($CodCCT);
                foreach($var_data as $row) {
                    $tmp['IdAdicional']=$row->IdAdicional;
                    $tmp['Adicional']=$row->Adicional;
                    $arr[]=$tmp;
                }
            

                echo json_encode($arr);
                
            }catch (Exception $e) {
                go_error($e);
        }



    }   


    public function calcularSueldo($CodigoCCT, $IdCat, $anioRecibo, $mesRecibo,$FechaIngreso,$Afiliado,$Vacaciones,$Adicionales){
        if(is_null($this->session->userdata('usuario')))
            redirect('login');
        try {
            //Permission::check(__METHOD__);   
            $this->load->model('CCTcategorias_model');
            $arr="";
        
                $var_data= $this->CCTcategorias_model->getCCTcalcularSueldo($CodigoCCT, $IdCat, $anioRecibo, $mesRecibo,$FechaIngreso,$Afiliado,$Vacaciones,$Adicionales);

                foreach($var_data as $row) {
                    $arr[]= array($row->Concepto,$row->Haberes,$row->Descuentos);
                    if ($row->Concepto=="Sueldo Basico") $SueldoBasico=$row->Haberes;  
                }
            echo json_encode($arr);
            
           

            } catch (Exception $e) {
                go_error($e);
        }
    }



}   