<?php
defined('BASEPATH') OR exit('No direct script access allowed');


if (!function_exists('add_log'))
{
    function add_log($action = null, $tabla = null, $IdTabla = null)
    {
        $CI =& get_instance();
        $CI->load->model('log_model');
        $CI->log_model->insert($action, $tabla, $IdTabla);  
    }
}

if (!function_exists('pre'))
{
    function pre($valor)
    {
        if(php_sapi_name() === "cli")
        {
            print_r($valor);
        }
        else
        {
            echo '<pre>' . print_r($valor, true) . '</pre>';      
        }
    }
}

if (!function_exists('format_fecha'))
{
    function format_fecha($valor)
    {
        if(!$valor)
            return '-';

        return date('Y-m-d H:i:s',strtotime($valor));    
    }
}

if (!function_exists('getEstadoColor'))
{
    function getEstadoColor($estado)
    {
        /*
        --blue: #007bff;
        --indigo: #6610f2;
        --purple: #6f42c1;
        --pink: #e83e8c;
        --red: #dc3545;
        --orange: #fd7e14;
        --yellow: #ffc107;
        --green: #28a745;
        --teal: #20c997;
        --cyan: #17a2b8;
        --white: #fff;
        --gray: #6c757d;
        --gray-dark: #343a40;
        --primary: #007bff;
        --secondary: #6c757d;
        --success: #28a745;
        --info: #17a2b8;
        --warning: #ffc107;
        --danger: #dc3545;
        --light: #f8f9fa;
        --dark: #343a40;
        */

        $color = array();
        $color['INICIADO'] = 'light';
        $color['CURSANDO'] = 'info';
        $color['VALIDADO'] = 'success';
        $color['RECHAZADO'] = 'danger';
        $color['PENDIENTE'] = 'warning';
        $color['FALTANTE'] = 'secondary';
        $color['PROCESADO'] = 'dark';
        $color['ENTREGADO'] = 'primary';

        return (array_key_exists($estado, $color) ? $color[$estado] : '');
    }
}





if (!function_exists('data'))
{
    function data($value)
    {
        return utf8_encode($value);
    }
}


if (!function_exists('getProvincias'))
{
    function getProvincias()
    {
        $CI =& get_instance();
        $CI->load->model('provincia_model');
        $result = $CI->provincia_model->getProvincia();
        return $result;
    }
}


if (!function_exists('getDepartamentos'))
{
    function getDepartamentos()
    {
        $CI =& get_instance();
        $CI->load->model('departamento_model');
        $result = $CI->departamento_model->getDepartamento();
        return $result;
    }
}


if (!function_exists('getRol'))
{
    function getRol($target)
    {
        switch ($target) {
            case 'ADMINISTRADOR':
                $r = 1;
                break;
            case 'CONTADOR':
                $r = 2;
                break;
            case 'COMPRAS':
                $r = 3;
                break;
            case 'USUARIO':
                $r = 4;
                break;
            default:
                $r = $target;
                break;
        }

        return $r;
    }
}

if (!function_exists('getRolStr'))
{
    function getRolStr($target)
    {
        switch ($target) {
            case 1:
                $r = 'ADMINISTRADOR';
                break;
            case 2:
                $r = 'VALIDA';
                break;
            case 3:
                $r = 'COMPRAS';
                break;
            case 4:
                $r = 'USUARIO';
                break;
            default:
                $r = $target;
                break;
        }

        return $r;
    }
}



if (!function_exists('is_administrator'))
{
    function is_administrator()
    {
        /*$CI =& get_instance();
        $allowed = array(getRol('ADMINISTRADOR'));
        return (in_array((int)$CI->session->userdata('usuario')->IdRol, $allowed) ? true : false );*/
        $CI =& get_instance();
        if ($CI->session->userdata('Perfil')=="Contador" or $CI->session->userdata('Perfil')=="Administrador"){
            return true;
        }else{
            return false;
        }
        
        
    }
}



if (!function_exists('is_usuario'))
{
    function is_usuario()
    {
        $CI =& get_instance();
        $allowed = array(getRol('USUARIO'));
        return (in_array((int)$CI->session->userdata('usuario')->IdRol, $allowed) ? true : false );
    }
}

if (!function_exists('go_referer'))
{
    function go_referer()
    {
        redirect($_SERVER['HTTP_REFERER']);
    }
}

if (!function_exists('go_back'))
{
    function go_back()
    {
        return (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : base_url());
    }
}

if (!function_exists('go_error'))
{
    function go_error($e = null)
    {
        $body = ($e->getMessage() ? $e->getMessage() : '');
        
        $msg = '';
        if($body)
        {
            $msg = base64_encode($body);
            $msg = str_replace('=', '', $msg);
        }

        // aca enviar mail a webmaster avisando del error notification();
        
        redirect(base_url("index.php/error/index/{$msg}"));
    }
}


    
