<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Afiliado_model extends CI_Model {

	 
 	public function getAfiliadoListado($IdEmpresa, $IdAfiliado,$Estado)
    {
        
        //$this->db->select ('IdAfiliado, CUIT, NroDocum, Apellido, ObraSocial, Sindicato, TresPorciento, FechaIngreso');
        $this->db->select ('IdAfiliado, a.IdEmpresa, Estado, CodTipoDocum, NroDocum, Apellido, Nombre, a.FechaIngreso, a.CUIL, NroInterno, CodEstadoCivil, CodSexo, FechaNacimiento, ObraSocial, Sindicato, Porcentaje, a.CodProvincia, a.CodDepartamento, a.CodLocalidad, a.Localidad, a.Calle, a.NumeroCalle, a.Telefono1, a.Telefono2, a.CodigoPostal, Plan, a.email, a.Observaciones, a.CodEstadoAfiliado, a.IdEmpresa, RazonSocial, IF(f.IdAfiliadoFam is null, 0, sum(if(f.FechaBaja is null, 1,0))) AS CantFamiliares ');
        

        $this->db->from('afiliado AS a');
        $this->db->join('familiar AS f', 'a.IdAfiliado=f.IdAfiliadoFam', 'left');
        $this->db->join('empresa AS e', 'a.IdEmpresa = e.IdEmpresa', 'left');


        if ($IdEmpresa!=0){
        	$this->db->where('a.IdEmpresa = '.$IdEmpresa);
            $this->db->where('a.Estado in ('.$Estado.')');
            /*$this->db->where('f.FechaBaja is null');       */
            
		}
        else{
            if ($IdAfiliado!=0){
                
                $this->db->where('IdAfiliado ='.$IdAfiliado);
                /*$this->db->where('f.FechaBaja is null');        */
                //$this->db->where('a.Estado in ('.$Estado.')');                
            }else{
                $this->db->where('a.Estado in ('.$Estado.')');
                /*$this->db->where('f.FechaBaja is null'); */       
            }

        }

        /*$this->db->where('a.FechaBaja IS NULL');*/
        
        $this->db->group_by('IdAfiliado, a.IdEmpresa, Estado, CodTipoDocum, NroDocum, Apellido, Nombre, FechaIngreso, a.CUIL, NroInterno, CodEstadoCivil, CodSexo, FechaNacimiento, ObraSocial, Sindicato, Porcentaje, CodProvincia, CodDepartamento, CodLocalidad, Localidad, Calle, NumeroCalle, Telefono1, Telefono2, CodigoPostal, Plan, email, Observaciones, CodEstadoAfiliado, IdEmpresa, RazonSocial'); 
        /*$this->db->where('CodProv > 0'); 

        $this->db->order_by("CodProv", "asc");*/

        $query = $this->db->get();
        //print_r($query);
        //echo $this->db->last_query();
        return $query->result();

    }

    public function getEstado()
    {
        $this->db->select ('CodEstado, Estado');
        $this->db->from('estado');
        $query = $this->db->get();
        return $query->result();
    }

 	public function getTipoDocum()
    {
        $this->db->select ('CodTipoDocum, TipoDocum');
        $this->db->from('tipodocum');
        $query = $this->db->get();
        return $query->result();
    }

    public function getEstadoCivil()
    {
        $this->db->select ('CodEstadoCivil, EstadoCivil');
        $this->db->from('estadocivil');
        $query = $this->db->get();
        return $query->result();
    }

    public function getSexo()
    {
        $this->db->select ('CodSexo, Sexo');
        $this->db->from('sexo');
        $query = $this->db->get();
        return $query->result();
    }

    public function getObservaciones($IdAfiliado)
    {
        $this->db->select ('Id, Fecha, Detalle, U.Usuario');
        $this->db->from('afiliado_observaciones AS AO');
        $this->db->join('usuario as U', 'AO.IdUsuario=U.IdUSuario', 'left');
        $this->db->where('IdAfiliado = '.$IdAfiliado.' and FechaBaja is null');
        $query = $this->db->get();
        //echo $this->db->last_query();
        return $query->result();
    }

    public function getHistorialCambioEmpresa($IdAfiliado)
    {
        $this->db->select ('Id, RazonSocial, FechaDesde, Usuario, Observacion');
        $this->db->from('afiliado_historial AS h');
        $this->db->join('empresa AS e', 'h.IdEmpresa=e.IdEmpresa', 'left');
        $this->db->join('usuario AS U', 'h.IdUsuarioAlta=U.IdUSuario', 'left');
        $this->db->where('IdAfiliado = '.$IdAfiliado);

 
        $query = $this->db->get();
        //echo $this->db->last_query();
        return $query->result();
    }

    

    public function getAfiliadoTipoDocumNroDocum($CodTipoDocum, $NroDocum){
        $this->db->select (' * ');

        $this->db->from('afiliado');

        $this->db->where('CodTipoDocum = '.$CodTipoDocum.' and NroDocum = '.$NroDocum);
        $query = $this->db->get();
        
        return $query->num_rows();

    }


    public function grabarAfiliado($post)
    {

        if($this->db->insert('afiliado', $post))
        return $this->db->insert_id();
        return false;
    }

    public function addObservacion($dataObservacion)
    {
        if($this->db->insert('afiliado_observaciones', $dataObservacion))
            return $this->db->insert_id();
        
        /*echo $this->db->last_query();*/
        return false;

    }

    
    public function addHistorial($dataHistorial)
    {
        if($this->db->insert('afiliado_historial', $dataHistorial))
            return $this->db->insert_id();
        
        echo $this->db->last_query();
        return false;

    }


    public function eliminarObservacion($IdObservacion, $IdUsuario)
    {   
        
       
        $Fecha = date('Y-m-d H:i');
        $this->db->set('FechaBaja', "'".$Fecha."'", FALSE);
        $this->db->set('IdUsuarioBaja', $IdUsuario, FALSE);
        $this->db->where('Id',$IdObservacion);
        $str = $this->db->update('afiliado_observaciones');
        
        return $str;
    }


    public function bajaActivarAfiliado($post)
    { 
        /*print_r($post);*/
        
        $query = $this->db->query("CALL spAfiliadoBajaActivar(".$post['EstadoNuevo'].", ". $post['IdAfiliadoBajaActivar']. ", ".$post['IdEmpresaAfiliadoBajaActivar'].",'". $post['FechaBajaActivar']."','".$post['ObservBajaActivarAfiliado']."', ".$this->session->userdata('IdUsuario').",'".date('Y-m-d')."')");
        $result = array();
        mysqli_next_result($this->db->conn_id);
        /*print $query->num_rows();*/
        //echo $this->db->last_query();
        if($query->num_rows() > 0)
            $result = $query->result_array();
        //echo $this->db->last_query();
        return $result[0];
       /* $data = array('name' => $name, 'email' => $email, 'phone' => $phone, 'address' => $address);*/
        
        
        
    }


    public function CambioEmpresaAfiliado($post)
    { 
        $query = $this->db->query("CALL spAfiliadoCambioEmpresa(".$post['IdAfiliadoCambioEmpresa'].", ". $post['IdEmpresaAfiliadoCambioEmpresaAnterior']. ", ".$post['IdAfiliadoCambioEmpresaActual'].",'". $post['FechaCambioEmpresa']."','".$post['ObservCambioEmpresaAfiliado']."', ".$this->session->userdata('IdUsuario').",'".date('Y-m-d')."')");
       $result = array();
       

       
        if($query->num_rows() > 0)
            $result = $query->result_array();
        //echo "sdd";
       // echo $this->db->last_query();
        return $result[0];
        
        
        
    }


    public function editarAfiliado($post,$IdAfiliado)
    {   
        //$IdEmpresa=540;
        $this->db->where('IdAfiliado',$IdAfiliado);
        if($this->db->update('afiliado', $post))
            return $IdAfiliado;

        return 0;
    }    

    public function eliminar($IdAfiliado)
    {   
        //$IdEmpresa=540;
        $str=0;
       
        $Fecha = date('Y-m-d H:i');
        $this->db->set('FechaBaja', "'".$Fecha."'", FALSE);
        $this->db->where('IdAfiliado',$IdAfiliado);
        $str = $this->db->update('afiliado');
        
        if($str!=0){
            $Fecha = date('Y-m-d H:i');
            $this->db->set('FechaBaja', "'".$Fecha."'", FALSE);
            $this->db->where('IdAfiliadoFam',$IdAfiliado);
            $str = $this->db->update('familiar');
        }
        return $str;
    }    

    

    

}
