<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Empresa_model extends CI_Model {

	public function getEmpresa()
    {
        
        $this->db->distinct();
        
        $this->db->select ('CUIT, RazonSocial');


        $this->db->from('empresa');

        $this->db->order_by("RazonSocial", "asc");

        $query = $this->db->get();
        
        return $query->result();


    }

    public function getListadoEmpresa($controlEstado,$CantEmpleados){
        $query= $this->db->query("CALL spListadoEmpresasCantEmpleados (".$controlEstado.", 0, ".$CantEmpleados.")");
        //echo $this->db->last_query();
        return $query->result();

    }


 	public function getEmpresas($CodProvincia, $CodDepartamento, $CodLocalidad, $CodCCT,$CantEmpleados, $Estado, $IdEmpresa)
    {
        
        $this->db->select ('e.IdEmpresa, e.RazonSocial, e.CUIT, e.CodProvincia, e.CodDepartamento, e.CodLocalidad, e.Calle, e.NumeroCalle, e.Domicilio, e.FechaDeclaracionJurada, e.FechaIngreso, e.CodCCT, CCT, Actividad, Telefono, TelefonoOtro, e.Email, e.CodigoPostal, Estudio, EstudioContacto, EstudioHorario, EstudioDireccion, EstudioTelefono, EstudioMail, Sucursal, p.provincia as Provincia, d.departamento as Departamento,  l.Localidad as Localidad, Lat, Lng, SUM(if(a.FechaBaja is null, 1, 0))  AS CantAfiliados');
        $this->db->from('empresa as e');
        $this->db->join('provincia as p', 'e.CodProvincia=p.CodProvincia', 'left');
        $this->db->join('departamento as d','e.CodProvincia=d.CodProvincia AND e.CodDepartamento=d.CodDepartamento', 'left');
        $this->db->join('localidad AS l', 'e.CodProvincia=l.CodProvincia AND e.CodDepartamento=l.CodDepartamento AND e.Codlocalidad=l.Codlocalidad', 'left');
        $this->db->join('afiliado AS a', 'e.IdEmpresa=a.IdEmpresa', 'left');
        $this->db->join('cct AS cc', 'e.CodCCT=cc.CodCCT', 'left');

if ($IdEmpresa==0){

        

			$this->db->where('(e.CodProvincia = "'.$CodProvincia.'" or "'.$CodProvincia.'"=0) and  (e.CodDepartamento = "'.$CodDepartamento.'" or "'.$CodDepartamento.'"=0) and  (e.CodLocalidad = "'.$CodLocalidad.'" or "'.$CodLocalidad.'"=0) and  (e.CodCCT = "'.$CodCCT.'" or "'.$CodCCT.'"=0)');


            if ($Estado==1){ //empresas activas
                 $this->db->where('e.FechaBaja is null');
            }                    

            if ($Estado==0){ //empresas no activas
                 $this->db->where('e.FechaBaja is not null');
            }                    

		}else{

			$this->db->where('e.IdEmpresa = '.$IdEmpresa);

            //$this->db->where('a.FechaBaja is null'); /* se agregó el 2020/12/02 */

            //$this->db->where('a.Estado<>9');

		}

        $this->db->group_by('IdEmpresa, RazonSocial, CUIT, CodProvincia, CodDepartamento, CodLocalidad, Calle, NumeroCalle, Domicilio, FechaDeclaracionJurada, FechaIngreso, e.CodCCT, Actividad, Telefono, TelefonoOtro, Email, CodigoPostal, Estudio, EstudioContacto, EstudioHorario, EstudioDireccion, EstudioTelefono, EstudioMail, Sucursal, p.provincia, d.departamento, l.Localidad'); 
        $this->db->order_by('IdEmpresa, RazonSocial, Sucursal');
       
        /*
        esto estaba sin comentar
        if ($IdEmpresa==0){
            if ($CantEmpleados==1){
                $this->db->having('CantAfiliados >= 0');
            }else{
                $this->db->having('CantAfiliados = 0');
            }
        }*/


        $query = $this->db->get();
        
       //echo $this->db->last_query();
        
        return $query->result();
    }

    public function getEmpresaCUITsucursal($CUIT, $Sucursal){
        $this->db->select (' * ');

        $this->db->from('empresa');

        //33679324239
        
        $this->db->where('CUIT = '.$CUIT.' and Sucursal = '.$Sucursal);
        $query = $this->db->get();
        
        return $query->num_rows();

    }

    public function getCantidadAfiliados($IdEmpresa)
    {
        $this->db->select ('e.CUIT, Sucursal, RazonSocial, COUNT(Sindicato) as AfiliadosSindicato, COUNT(ObraSocial) as AfiliadosObraSocial, COUNT(Porcentaje) as AfiliadosPorcentaje, COUNT(*) as nroafiliados');
        $this->db->from('empresa e');
        $this->db->join('afiliado a', 'e.IdEmpresa=a.IdEmpresa', 'left');
        $this->db->where('e.IdEmpresa = '.$IdEmpresa.' AND e.FechaBaja IS NULL AND a.FechaBaja IS NULL AND a.IdAfiliado>0');
        $query = $this->db->get();
        return $query->result();
    }
        
    public function getObservaciones($IdEmpresa)
    {
        $this->db->select ('Id, Fecha, Detalle, Usuario');
        $this->db->from('empresa_observaciones AS EO');
        $this->db->join('usuario as U', 'EO.IdUsuario=U.IdUSuario', 'left');
        $this->db->where('IdEmpresa = '.$IdEmpresa.' and FechaBaja is null');
        $query = $this->db->get();
        return $query->result();
    }


    public function grabarEmpresa($post)
    {
        //pre($post);

        //$post = $this->cleanPostFields($post);

        //pre($post);

        if($this->db->insert('empresa', $post))
            return $this->db->insert_id();
        
        return false;
    }

    public function editarEmpresa($post,$IdEmpresa)
    {   
        if(!$IdEmpresa)
            return false;
        $this->db->where('IdEmpresa',$IdEmpresa);
        if($this->db->update('empresa', $post)){
            //echo $this->db->last_query();
            return $IdEmpresa;
        }
        //echo $this->db->last_query();
        return false;
    }    

    public function addObservacion($dataObservacion)
    {
        if($this->db->insert('empresa_observaciones', $dataObservacion))
            return $this->db->insert_id();
        
        /*echo $this->db->last_query();*/
        return false;

    }

    public function eliminarObservacion($IdObservacion, $IdUsuario)
    {   
        
       
        $Fecha = date('Y-m-d H:i');
        $this->db->set('FechaBaja', "'".$Fecha."'", FALSE);
        $this->db->set('IdUsuarioBaja', $IdUsuario, FALSE);
        $this->db->where('Id',$IdObservacion);
        $str = $this->db->update('empresa_observaciones');
        
        return $str;
    }

    public function bajaActivarEmpresa($post)
    { 
        //print_r($post);
        /*EstadoActivarBaja, IdEmpresaBajaActivar, RazonSocialEmpresaBajaActivar, FechaBajaActivar, MotivoBajaActivarEmpresa*/
        $query = $this->db->query("CALL spEmpresaBajaActivar(".$post['EstadoActivarBaja'].", ".$post['IdEmpresaBajaActivar'].",'". $post['FechaBajaActivar']."','".$post['MotivoBajaActivarEmpresa']."', ".$this->session->userdata('IdUsuario').",'".date('Y-m-d')."')");
        $row = array();
        $row = $query->result();
        //echo $this->db->last_query();
        $query->next_result();
        $query->free_result();
        return $row;
    }

}
